.include "cpctelera.h.s"
.include "Cabeceras/Game_Manager.h.s"
.include "Cabeceras/Cpctelera_Functions.h.s"
.include "Cabeceras/Entity_Manager.h.s"
.include "Cabeceras/Input.h.s"
.include "Cabeceras/Physics.h.s"
.include "Cabeceras/Render.h.s"
.include "Cabeceras/AI.h.s"
.include "Cabeceras/Colision.h.s"
.include "Cabeceras/Animation.h.s"
.include "Cabeceras/Ai_Manager.h.s"

halt2:: .dw #0x0000
aux: .db #6
_ctr:: .db 0x00 
deaths: .dw 0x0000
cronometro:: .dw 0x0000

DefineEntity hero_data, 0x18, 0xA0, 0x00, 0x00, 0x04, 0x08, #-1, 0, #_Full_Player_sp_00,  #-1, #-1, #0x0000,     #-1, #1, 0x05, 0xA0, #1,#-1, player_idle, #0, #0x0000
DefineEntity enemy    , 0x00, 0x00, 0x01, 0x00, 0x04, 0x08, #-1, 0, #_Enemy_sp_0          #2, #50, AI_Platform,  #-1, #50, 0x00, 0x00, #2,#-1, player_idle, #0, patrol_array
DefineEntity enemy1   , 0x00, 0x00, #0x00, 0x00, 0x04, 0x08, #-1, 0, #_Enemy_sp_0          #2, #50, AI_Platform,  #-1, #50, 0x00, 0x00, #2,#-1, player_idle, #0, patrol_array
DefineEntity enemy2   , 0x00, 0x00, 0x01, 0x00, 0x04, 0x08, #0x30, #0x20, #_Enemy2_sp     #3, #50, AI_Platform,  #1, #50, 0x00, 0x00, #2, #0, enemy3s, #0, patrol_array
DefineEntity enemy3   , 0x00, 0x00, 0x01  0x00, 0x04, 0x08, #0x30, #0x20, #_Enemy3_sp_0     #4, #50, AI_Platform,  #1, #40, 0x00, 0x00, #2, #0, enemy3_right, #0, patrol_array
DefineEntity enemy4   , 0x00, 0x00, 0x01  0x00, 0x04, 0x08, #0x30, #0x20, #_Enemy3_sp_0     #4, #50, AI_Platform,  #1, #90, 0x00, 0x00, #2, #0, enemy3_right, #0, patrol_array
DefineEntity enemy5  , 0x00, 0x00, 0x01  0x00, 0x04, 0x08, #0x30, #0x20, #_Enemy3_sp_0     #4, #50, AI_Platform,  #1, #50, 0x00, 0x00, #2, #0, enemy3_right, #0, patrol_array
DefineEntity enemy6   , 0x00, 0x00, 0x01  0x00, 0x04, 0x08, #0x30, #0x20, #_Enemy3_sp_0     #4, #50, AI_Platform,  #1, #50, 0x00, 0x00, #2, #0, enemy3_right, #0, patrol_array
DefineEntity enemy7   , 0x00, 0x00, 0x01, 0x00, 0x04, 0x08, #0x30, #0x20, #_Enemy4_sp_0    #5, #50, AI_Platform,  #1, 100, 0x00, 0x00, #2, #0, enemy4_right, #0, patrol_array
DefineEntity enemy8   , 0x00, 0x00, 0x01, 0x00, 0x04, 0x08, #0x30, #0x20, #_Enemy4_sp_0    #5, #50, AI_Platform,  #1, #50, 0x00, 0x00, #2, #0, enemy4_right, #0, patrol_array

music: .db 0x00

itr:
 
  ld hl, (halt2)
  inc hl
  ld (#halt2),hl
  dec h
  inc h
  jr z, scan
  ld a, l
  cp #0x2C
  jr nz, scan
  jr second


  second:
  ld hl, #cronometro 
  inc (hl)
  ld bc, #0
  ld (halt2), bc
  

  scan:
  
  call cpct_scanKeyboard_if_asm
 
  ex af, af'
  exx
  push af
  push bc
  push de
  push hl
  push iy

  ld a, (aux)
  dec a
  ld (aux), a
  jr nz, return

    ld a, (music)
    cp #0
    jr nz, return
    call z, cpct_akp_musicPlay_asm  
    ld a, #6
    ld (aux), a


   


    return:
    pop iy
    pop hl
    pop de
    pop bc
    pop af
    exx
    ex af, af'
    
    ld a,(#_ctr)
    inc a
    ld hl,#_ctr
    ld (hl), a



  ret  




Game_Init:

   ld de, #_sfx
   call cpct_akp_SFXInit_asm
   ld de, #_musica
   call cpct_akp_musicInit_asm
   ld hl,#itr
   call cpct_setInterruptHandler_asm

   call Render_Init
   call Entity_Manager_Init
   call Physics_Init
   call Input_Init
   call AI_Init
   call Animation_Init

   ld	hl, #hero_data
   call Entity_Create
   ld	hl, #enemy
   call Entity_Create
   ld	hl, #enemy1
   call Entity_Create
   ld	hl, #enemy2
   call Entity_Create
   ld	hl, #enemy3
   call Entity_Create
   ld	hl, #enemy4
   call Entity_Create
   ld	hl, #enemy5
   call Entity_Create
   ld	hl, #enemy6
   call Entity_Create
   ld	hl, #enemy7
   call Entity_Create
   ld	hl, #enemy8
   call Entity_Create






 

ret


Game_Update:



call Entity_getArray
call Input_Update
call Entity_getArray
call Physics_Update
call Entity_getArray
call AI_Update
call Entity_getArray
call Colision_Entity
call Entity_getArray
call Animation_Update




ret

Game_Render:
call Entity_getArray
call Render_Update
call Entity_getArray


;call Animation_ResetFrame


ret


Game_getCtr::
ld a,(#_ctr)
ret

Game_setCtr::
ld hl,#_ctr
ld (hl), a
ret
