.include "cpctelera.h.s"
.include "Cabeceras/Game_Manager.h.s"
.include "Cabeceras/Cpctelera_Functions.h.s"
.include "Cabeceras/Entity_Manager.h.s"
.include "Cabeceras/Input.h.s"
.include "Cabeceras/Physics.h.s"
.include "Cabeceras/State_Manager.h.s"
.include "Cabeceras/Sound.h.s"

 

no_input: .db 00 

_wallTimer: .db 00
_wallDirection: .db 00

Input_Init::

ret

Input_Update::


   
   ld hl, #Key_M              ;;Comrpuebo a pulsada
   call cpct_isKeyPressed_asm
   jr nz, mute


   

   ld hl, #Key_U              ;;Comrpuebo a pulsada
   call cpct_isKeyPressed_asm
   jr nz, unmute
   jr begin

   mute:
   call cpct_akp_stop_asm
   ld a, #1
   ld (music), a
   jr begin

   unmute:
   ld a, #0
   ld (music), a
   ld de, #_musica
   ;call cpct_akp_musicInit_asm
   call cpct_akp_musicPlay_asm  

    begin:
 
   call Input_jump
   call Input_dash
   call Input_WallJump
  
  ld a,(no_input)

   ld	e_vx(ix),#0   

   ld hl, #Key_P               ;;Comrpuebo a pulsada
   call cpct_isKeyPressed_asm
   jr z,   p_not        

      ld b, #3
      call stateman_changeState
      ret          ;;Si esta pulsada, velocidad negatica(izq)
        
   p_not:

  
  ld	e_vx(ix),#0 
      ld a,(no_input)
      cp #1
      jr z, a_not
      ld hl, #Key_A                 ;;Comrpuebo a pulsada
      call cpct_isKeyPressed_asm
      jr z,   a_not        ;; Si NO esta pulsada salto

         ;move_izq
         ld	a, e_x(ix)
         cp	#0
         jr z, a_not          ;;Comprebo limite izq


         ld	e_vx(ix),#-1              ;;Si esta pulsada, velocidad negatica(izq)
        
   a_not:
      ld a,(no_input)
      cp #-1
      jr z, d_not
      ld hl, #Key_D                 ;; Compruebo d pulsada
      call cpct_isKeyPressed_asm
      jr z,  d_not        ;; Si NO esta pulsada salto
      
         ;;muevo_drz
         
         
       
         ld	e_vx(ix), #1             ;; Si no esta pulsada, velocidad positiva(drz)
         
   d_not:

        
   
      ld hl, #Key_Space               ;; Compruebo space pulsado
      call cpct_isKeyPressed_asm
      cp	#0
      jr z, move       ;; Si NO esta pulsada salto
         
         push hl
         ld l, #1
         ld h, #13
         ;call Play_sound
         pop hl
         ld a, e_air(ix)
         cp #-1
         jr nz, move
         ;;salto
      
         call Init_jump        ;; Si no esta pulsada, velocidad positiva(drz)


   move:                 ;; Ninguna esta pulsada


 call Dash_check ;; Compueba si se puede hacer un desplazamiento en el aire
ret
   
ret



Input_GetBack:
 call cpct_scanKeyboard_asm
     ld hl, #Key_Q
     call cpct_isKeyPressed_asm
     ret z
     ld hl,#_menu
      ld (hl), #0
      call stateman_changeState
 


Input_Menu:
   call cpct_scanKeyboard_asm
     ld hl, #Key_1
     call cpct_isKeyPressed_asm
     jr z, _noKey

      ld b, #1
      call stateman_changeState
     
     _noKey::
      ld hl, #Key_2
      call cpct_isKeyPressed_asm
      ret z
      ld hl,#_menu
      ld (hl), #1
      call stateman_changeState
ret


Init_jump::


  
 ld  a, e_air(ix)
 cp #-1 
 ret nz


 ld a, e_collider(ix)
 cp #-1
 ret z

 ld	a, e_jump(ix)
 cp	#-1               ;;Si jump es -1 no hace nada
 ret	nz




 ld	a, #0
 ld	e_jump(ix), a     ;;Si es 0 activa el control de salto
 
  

ret


Input_jump:
  
   
   ld a, e_collider(ix)
   cp #-1
   ret z

   ld a, e_wall(ix)
   cp #0
   ret z

   ld  a, e_air(ix)
   cp #-1 
   jr nz, fin


   

   ld	a, e_jump(ix)
   cp	#-1            ;;si e_jump es -1 No salto y vuelvo
   ret z
   jump:
      ld a,e_jump(ix)
   ;; Obtener dato/Saltando
      ld	hl, #jumptable
      ld c , a                 ;;HL->puntero a jumptable
      ld b , #0                ;;Indice de la tabla
      add	hl, bc

      ;Fin salto

      ld	a, (hl)
      cp	#0x80
      jr	z, fin            ;;Si es 80 paro el salto

     
      
      ;;Saltar
      push af

  
      
      pop af
      ld	b, a              ;;movimiento
      ld a, e_y(ix)             
      add	b
      ld e_y(ix), a         ;; vamos variando la posicion del players

      ld a, e_y(ix)
      add #-4
      
      jr z, fin
     
     

      ld	a, e_jump(ix)
      inc	a                ;; vamos incrementando el valor 
      ld e_jump(ix), a

      ret


      fin:
      ld	a, #-1
      ld	e_jump(ix), a
      ld e_air(ix), #1
      ret 

      


ret


Init_dash::


 ld	a, e_dash(ix)
 cp	#-1               ;;Si el dash es -1 no hace nada
 ret	nz


 ld	a, #0
 ld	e_dash(ix), a     ;;Si es 0 activa el control del deslizamiento
 


ret


Input_dash::
  
   ld	a, e_dash(ix)
   cp	#-1        ;;si el e_dash es -1 No salto y vuelvo
   ret z
  
   ld e_mestampao(ix),#0

   ld e_vy(ix),#0
   
   ;; Obtener dato/Saltando
   ld	hl, #hyperdash
   ld c , a                 ;;HL->puntero a jumptable
   ld b , #0                ;;Indice de la tabla
   add	hl, bc

   ;Fin salto

   ld	a, (hl)
   cp	#0x80
   jr	z, end_dash            ;;Si es 80 paro desplazamiento

   ;;Saltar

   ld	b, a              ;;movimiento
   push bc


   ld c,a
   ld a, e_vx(ix)
   
   cp #0 ;; Si vx<0 se resta el data table

   jp m, restar
  
   jr z, end_dash
   
   ld a, e_x(ix)
   cp #80-4
   jr z, end_dash
   add b
  
   ld h, #0x42
   ld l, #0x30
   ld e_sptr_l(ix), l
   ld e_sptr_h(ix), h

    ld de, #CPCT_VMEM_START_ASM
    ld	c, e_x(ix)
    ld	b, e_y(ix)

    ld a, e_w(ix)
    add c
    ld c,a

    ld	a, #7
    add b
    ld b, a

    call cpct_getScreenPtr_asm   

    
    ld a, (hl)                                      
    cp #0
    jr nz, end_dash
      pop bc
      ld a, e_x(ix) ;; Si vx>0
      add b

   jr posicion ;; Varia la posicion de player
   
   
   restar:
    
      ld a, e_x(ix)
      cp #0
      jr z, end_dash

      sub b


      ld h, #0x42
      ld l, #0x70
      ld e_sptr_l(ix), l
      ld e_sptr_h(ix), h

      

      ld de, #CPCT_VMEM_START_ASM
      ld	c, e_x(ix)
      ld	b, e_y(ix)

      ld a, #-1
      add c
      ld c,a

      ld	a, #7
      add b
      ld b, a

   

      call cpct_getScreenPtr_asm   

      
      ld a, (hl)                                      
      cp #0
      jr nz, end_dash
           pop bc
         ld a, e_x(ix) ;; Si vx>0
         sub b
      
  
   posicion:
   
   
      
      ld e_x(ix), a         ;; vamos variando la posicion del players
      


      ld	a, e_dash(ix)
      inc	a                ;; vamos incrementando el valor 
      ld e_dash(ix), a

      ret

   end_dash:
   pop bc
   ld e_dash(ix), #-1
  
ret


Dash_check:

   ld hl, #Key_Shift
     call cpct_isKeyPressed_asm
     jr z, _noKey2
     

      ld a, e_air(ix)
      cp #-1
      ret z

      ld a, e_mestampao(ix)
      cp #0
      ret z


      ld a, e_jump(ix)
      cp #-1
      ret nz
     push hl
     ld l, #1
     ld h, #15
     call Play_sound
     pop hl
     call Init_dash ;; Inicializa el comprobador de dashes
        
   
     _noKey2:: ret
  ret




Input_Pause:
  
     ld hl, #Key_Q
     call cpct_isKeyPressed_asm
     jr z, _noKeyP

      ld b, #3
      call stateman_changeState
     
     _noKeyP:: ret
ret	

Input_End:
call cpct_scanKeyboard_asm
     ld hl, #Key_Q
     call cpct_isKeyPressed_asm
     jr z, _noKeyP
      
      ld b, #1
      call stateman_changeState
ret

Input_Wall:

   ld hl, #Key_Space
     call cpct_isKeyPressed_asm
     jr z, _noWall

      call Init_WallJump
      
     
   
     _noWall:: ret
  ret









Init_WallJump:

   ld a,e_collider(ix)
   cp #-1
   ret nz

   ld e_jump(ix), #0

   ld e_wall(ix),#0
   ex af,af'
   ld hl, #_wallDirection
   ld (hl), a
ret




Input_WallJump:

    ld	a, e_jump(ix)
   cp	#-1            ;;si e_jump es -1 No salto y vuelvo
   ret z

   ld	a, e_wall(ix)
   cp	#-1            ;;si e_jump es -1 No salto y vuelvo
   ret z
      
   ld a, (#_wallTimer)
   inc a
   cp #6

   jp z, walljump_end
   
   ld hl, #_wallTimer
   ld (hl), a



   wall_jump:

   ld a, (#_wallDirection)
   
   cp #-1
 
   jr z,  wall2Lft

   

    wall2Rgt:

    ld a, #1
    call cancelInput
    
    
    
    ld a, #1
  
    ld e_vx(ix), a

    
    call Physics_Right
    


    ld a, e_x(ix)
    ld b, e_vx(ix)
    add b
    ld e_x(ix),a

      
        
    

     ld a, e_vx(ix)
     cp #0
     jr z,none 
      ld a,#-2
      jr setWVx
    none:
      ld a,#0
      
    setWVx:
    ld e_vy(ix), a 

    call Physics_Top
    
    
    ld a, e_y(ix)
    ld b, e_vy(ix)
    add b

    ld e_y(ix), a
    
   
    
    ret




   wall2Lft:

      ld h, #0x41
      ld l, #0xF0
      ld e_sptr_l(ix), l
      ld e_sptr_h(ix), h
   

      ld a, #-1
      ;call cancelInput
      ld a, #-1
      ld e_vx(ix), a

      call Physics_Left  
      
      ld a, e_x(ix)
      ld b, e_vx(ix)
      add b
      ld e_x(ix),a

      

     ld a, e_vx(ix)
     cp #0
     jr z,none2
      ld a,#-2
      jr setWV_x
    none2:
      ld a,#0
      
    setWV_x:
    ld e_vy(ix), a 

      
      ld e_vy(ix), a

      call Physics_Top
      
      
      ld a, e_y(ix)
      ld b, e_vy(ix)
      add b
      
      ld e_y(ix), a
 
     
    ret

 



    
   jr walljump_end

   walljump_end:
      ld hl,#_wallTimer
      ld a, #0
      ld (hl), a
      call cancelInput
      ld e_air(ix), #1
      ld e_jump(ix), #-1
      ld e_wall(ix),#-1
   ret

ret

;;;;;;;;;;;;;;;;;;;;;;;;;;
   ;  cancelInput
   ;; Input - A ;;
   ;; Destroy - AF ;;
;;;;;;;;;;;;;;;;;;;;;;;;;
cancelInput::
   ld (no_input), a
ret

