.include "Cabeceras/Map.h.s"
.include "Cabeceras/Map_Manager.h.s"
.include "cpctelera.h.s"
.include "Cabeceras/Cpctelera_Functions.h.s"
.include "Cabeceras/Entity_Manager.h.s"
.include "Cabeceras/Game_Manager.h.s"
.include "Cabeceras/State_Manager.h.s"


Map_CheckEnd:

    call Entity_getArray


    ld de, #CPCT_VMEM_START_ASM
    ld	c, e_x(ix)
    ld	b, e_y(ix)

    ld a, #3
    add c
    ld c,a

    ld	a, #8
    add b
    ld b, a

    call cpct_getScreenPtr_asm   
                       

    ld a, (hl)                                      
    cp #0xCF

ret


Map_PtrManager:



  ld hl, (contador)
  ld de, #_map_array
  add hl, de
  ld d, h
  ld e, l
  ld ix, #0

  add ix, de
  

  ld	h, _end_h(ix)
  ld	l, _end_l(ix)
  ld c, _off_l(ix)
  ld b, _off_h(ix)
  add hl, bc
  
  ld a, (_current_map)
  cp #10
  jr z, change
  cp #26
  jr z, change
  cp #37
  jr z, change
  cp #50
  jr z, change
  ld	de, #0x233
  jr no_change

  change:
  ld	de, (decompress_buffer_end)
  no_change:
  call cpct_zx7b_decrunch_s_asm

  ld	bc, #0x1914
  ld	de, #20
  ld	hl, #tilset_ptr
  call cpct_etm_setDrawTilemap4x8_ag_asm

  ld   bc, (contador)
  ld   hl,  #maps_size
  add hl, bc
  ld b, h
  ld c, l
  ld   (contador), bc
  
  
ret


Map_UpdateEntities:


  call Entity_getArray


  ld hl, (contador)
  ld de, #_map_array
  add hl, de
  ld d, h
  ld e, l
  ld iy, #0
  add iy, de
  

  loop_:

  push af


  ld  d,  (iy)
  ld e_x(ix), d
  ld e_level_posx(ix), d
  ld d, e_move(ix)
  ld e_dash(ix), d

  inc iy
  ld	e,  (iy)
  ld e_level_posy(ix), e
  ld e_y(ix), e   
  ld d, e_move(ix)
  ld e_dash(ix), d
  ld a, e_vx(ix)
  cp #0xFF
  jr nz, next
  neg
  ld e_vx(ix), a

  next:
  
  push af
  push bc
  push de 
  push hl
  ld de, #0xC000
  ld c, e_x(ix)
  ld b, e_y(ix)
  call cpct_getScreenPtr_asm
  ld e_paint_h(ix), h
  ld e_paint_l(ix), l
  pop hl
  pop de
  pop bc
  pop af

  pop af
  
  ld bc, #entity_size
  add ix, bc
  inc iy
  dec a
  jr nz, loop_

ret


Map_Update:



call cpct_scanKeyboard_asm
ld hl, #Key_N            ;;Comrpuebo a pulsada
call cpct_isKeyPressed_asm
jr nz, pulsed


check:
call Map_CheckEnd
jr z, jump
jr not_end

pulsed:
ld a, #0
cp #0


jr nz, not_end
    jump:
  
    call Map_endGame
    call Map_PtrManager
    call Map_UpdateEntities
    call Map_Render



not_end:

ret	




Map_endGame:
    ld a, (#_current_map)
    inc a
    ld (#_current_map), a
    ld  a, (#_current_map)
    ld b,a
    ld a, (#_num_maps)
    
    sub b
    ret nz
    finish_game:
    ld b, #4
    call stateman_changeState 
ret




Map_Render:

  call cpct_akp_stop_asm
  ld de, #_musica
  call cpct_akp_musicInit_asm
  ld	hl, #0xC000
  ld	de, #tilmap_ptr
  call cpct_etm_drawTilemap4x8_ag_asm
   

ret	