.include "cpctelera.h.s"
.include "Cabeceras/Game_Manager.h.s"
.include "Cabeceras/State_Manager.h.s"
.include "Cabeceras/Cpctelera_Functions.h.s"
.include "Cabeceras/Entity_Manager.h.s"
.include "Cabeceras/Render.h.s"
.include "Cabeceras/Physics.h.s"


lastx:: .db #00
lasty:: .db #00


screen_start: .db 0xC0


Render_Init:

  call cleanMem
  cpctm_setBorder_asm #HW_SKY_BLUE
  ld	c, #0
  call cpct_setVideoMode_asm


ret




Render_Update:

call Render_Entities

ret





Render_Entities:



 call Entity_getArray

  ld	(count), a

 r_loop:

  ld a, e_y(ix)
  cp #0
  jr z, not_x
  jr seguir

  not_x:
  ld a, e_x(ix)
  cp #0
  jr z, not_render


  seguir:



  ld	e, e_paint_l(ix)
  ld	d, e_paint_h(ix)
  xor	a

  ld	c, e_w(ix)
  ld	b, e_h(ix)

  call cpct_drawSolidBox_asm

  
   ld	a, (screen_start)
   ld d, a   ;; Comienzo memoria de Video
   ld	e, #0
   ld c,  e_x(ix)       ;; C= Entity Y
   ld b,  e_y(ix)        ;; b= Entity X
   call	cpct_getScreenPtr_asm

  ld e_paint_l(ix), l
  ld e_paint_h(ix), h

  ex	de, hl
  ld	h, e_sptr_h(ix)
  ld	l, e_sptr_l(ix)
  ld	c, e_w(ix)
  ld	b, e_h(ix)

 
  call	 cpct_drawSprite_asm


   not_render:
   count = .+1
   ld	a, #0
   dec	a
   jr z, end_

   ld	(count), a
   ld	bc, #entity_size
   add	ix, bc
   jp	r_loop
   
   end_:

   ret
   
   
   
Render_Reset::
   ld   de, #CPCT_VMEM_START_ASM ;; DE = Pointer to start of the screen
   ld    b, #0                 ;; B = y coordinate (24 = 0x18)
   ld    c, #0                 ;; C = x coordinate (16 = 0x10)
        
  
  call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL
  push hl 

  ex	de, hl
  ld a, #0      ;; Color
  ld b, #50     ;; Alto
  ld c, #64      ;; Ancho
       
  call cpct_drawSolidBox_asm
  
  pop hl

  ld bc,#60
  add hl,bc

  ex de, hl
  ld a, #0      ;; Color
  ld b, #50     ;; Alto
  ld c, #20    ;; Ancho
       
    

  call cpct_drawSolidBox_asm
   ret

   
